#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct t_file_pointer //To be reused with file table regeneration
{
	unsigned char address1;
	unsigned char address2;
        unsigned char address3;
	unsigned char off_value;
};

long sector_j;

unsigned char minute;  //Values used for timestamp in sector header
unsigned char second;
unsigned char frame;

unsigned char user_data[2352];
unsigned char inbuf_copy[2448];

long filesize(FILE *f_iso);
int check_iso(FILE *f_iso);
void read_file_pointer(FILE *f_iso,unsigned char user_data[]);
void sector_seek(FILE *f_iso, int sector);
void jump_over_cd_header(FILE *f_iso);
void jump_over_cd_edc_ecc(FILE *f_iso);
void file_dump(FILE *f_iso,long debut, long fin,int j,unsigned char user_data[]);
long get_iso_pointer_position(int position);
void reinsert(FILE *f_iso,char *file_name,unsigned char user_data[],t_file_pointer tab_new[],t_file_pointer tab_source[],long *tab_position);


#include "yazedc"

void change_base(unsigned char *valeur)
{
	if(*valeur==10) *valeur=16;
	if(*valeur==26) *valeur=32;
	if(*valeur==42) *valeur=48;
	if(*valeur==58) *valeur=64;
	if(*valeur==74) *valeur=80;
	if(*valeur==90) *valeur=96;
	if(*valeur==106) *valeur=112;
	if(*valeur==122) *valeur=128;
}

void update_time()
{
	frame++;
	change_base(&frame);

	if (frame==117)
	{
		second++;
		change_base(&second);
		frame=0;
	}
	if (second==96)
	{
		minute++;
                change_base(&minute);
		second=0;
	}
}

void iso_header_copy(FILE *f_iso,FILE *f_source)
{
	char valeur;
	long i;

	for(i=0;i<89376;i++)
	{
		fread((char *)&valeur,1,1,f_source);
		fwrite(&valeur,1,1,f_iso);
	}
}

void write_synchro_code(FILE *f_iso)
{
	user_data[0]=0;
	user_data[1]=255;
	user_data[2]=255;
	user_data[3]=255;
	user_data[4]=255;
	user_data[5]=255;
	user_data[6]=255;
	user_data[7]=255;
	user_data[8]=255;
	user_data[9]=255;
	user_data[10]=255;
	user_data[11]=0;
}

void read_source_tab(FILE *f_tab,t_file_pointer tab_source[])
{
	int i;
	unsigned char valeur1;
	unsigned char valeur2;
	unsigned char valeur3;


	for(i=0;i<6060;i++)
	{
		fread((char *)&tab_source[i].address1,1,1,f_tab);
		fread((char *)&tab_source[i].address2,1,1,f_tab);
		fread((char *)&tab_source[i].address3,1,1,f_tab);
		fread((char *)&tab_source[i].off_value,1,1,f_tab);
	}
}

int main(void)
{
	unsigned long j;
	FILE *f_iso;
	FILE *f_source;
	FILE *f_tab_source;
	FILE *f_tab;
	int position;
	long pointer_position;
	char name[100];
	char temp_name[100];
	t_file_pointer tab_source[6070];
	t_file_pointer tab_new[6070];
	long tab_position;

	f_tab_source = fopen("cclist", "rb");
	read_source_tab(f_tab_source,tab_source);
	fclose(f_tab_source);

	f_iso = fopen("..\\hiso\\hCD1.iso", "wb+");	//The new generated ISO
	f_source = fopen("boot.dat","rb");   //The boot Sectors

	iso_header_copy(f_iso,f_source);	//Copy the 37 first sectors

	fclose(f_source);       //Close source iso

	minute=0;       //Initialise the time tag where the PS-EXE start
	second=2;
	frame=56;	//I use 56 to make the sector 38 in hexa

	sector_j=38;  //We start reinsertion at sector 38d -> 26h

	tab_position=0; //We start at position 0 of the file table

	for(j=0;j<5618;j++) //5618
	{
		printf("Reinserting file %d.\n",j);          //Print to screen the jber of the file being reinserted

		sprintf(temp_name,"%d",j); //File name generation for the reinserted file according to it's jber
		strcpy(name,"..\\");

	if((j>=0)&&(j<=24))					//  0-   24 Misc
		strcat(name,"MISC");

	if((j>=25)&&(j<=74))				//  25-  74 Character Faces
		strcat(name,"CF");

	if((j>=75)&&(j<=125))				//  75- 125 Character Descriptions
		strcat(name,"CD");

	if((j>=126)&&(j<=178))				// 126- 178 Rare objects TIM
		strcat(name,"ROT");

	if((j>=179)&&(j<=185))				// 179- 185 Misc
		strcat(name,"MISC");

	if((j>=186)&&(j<=189))				// 186- 189 Rare objects TIM
		strcat(name,"ROT");

	if((j>=190)&&(j<=203))				// 190- 203 Misc
		strcat(name,"MISC");

	if((j>=204)&&(j<=307))				// 204- 321 OverWorld Main Characters Models
		strcat(name,"OMCM");

	if((j>=308)&&(j<=221))				// 190- 203 Misc
		strcat(name,"MISC");

	if((j>=322)&&(j<=331))				// 322- 331 OverWorld Alternate Models
		strcat(name,"OAM");

	if((j>=332)&&(j<=355))				// 332- 355 Misc
		strcat(name,"MISC");

	if((j>=356)&&(j<=1966))				// 356-1966 Rooms
		strcat(name,"Rooms");

	if((j>=1967)&&(j<=1977))			//1967-1977 Misc
		strcat(name,"MISC");

	if((j>=1978)&&(j<=1992))			//1978-1992 Windows frame
		strcat(name,"WF");

	if((j>=1993)&&(j<=2084))			//1993-2084 Character talking face
		strcat(name,"CTF");

	if((j>=2085)&&(j<=2416))			//2085-2416 Misc
		strcat(name,"MISC");

	if((j>=2417)&&(j<=2513))			//2415-2513 BattleFields
		strcat(name,"BF");

	if((j>=2514)&&(j<=2542))			//2514-2542 Misc
		strcat(name,"MISC");

	if((j>=2543)&&(j<=3054))			//2543-3054 Battlescript
		strcat(name,"BS");

	if((j>=3055)&&(j<=3707))			//3054-3707 Misc
		strcat(name,"MISC");

	if((j>=3708)&&(j<=3759))			//3708-3759 Small Character Layer
		strcat(name,"SCL");

	if((j>=3760)&&(j<=5597))			//3760-5597 Misc
		strcat(name,"MISC");

	if(j>=5598)							//5598-5918 Video
		strcat(name,"V");

		strcat(name,"\\");

		strcat(name,"disk1\\");

		if(j<10)
			strcat(name,"0");
		if(j<100)
			strcat(name,"0");
		if(j<1000)
			strcat(name,"0");
		strcat(name,temp_name);

		reinsert(f_iso,name,user_data,tab_new,tab_source,&tab_position);  //Launch the reinsertion of the actual file
	}

	f_tab=fopen("9999.out","wb+");
	for(j=0;j<6060;j++)
	{
		fwrite(&tab_new[j],sizeof(tab_new[j]),1,f_tab);
	}
	fclose(f_tab);

	fseek(f_iso,56448,SEEK_SET);

	minute=0;
	second=2;
	frame=36;

	strcpy(name,"9999");
	tab_position=6061;
	tab_source[tab_position].address1=0;
	tab_source[tab_position].address2=0;
	tab_source[tab_position].address3=0;
	reinsert(f_iso,name,user_data,tab_new,tab_source,&tab_position);

	fclose(f_iso);		//Close generated iso
	return 0;
}

long filesize(FILE *f_iso)
{
	long curpos, length;
	curpos = ftell(f_iso);
	fseek(f_iso, 0L, SEEK_END);
	length = ftell(f_iso);
	fseek(f_iso, curpos, SEEK_SET);
	return length;
}

int check_iso(FILE *f_iso)	//Should be used to check source iso
{
	long length;
	long cd1_length=736651104;
	length=filesize(f_iso);
	printf("Filesize of chrono1.iso is %ld bytes\n", length);
	if (length!=cd1_length)
	{
	 return(1);
	}
	return(0);
}

void write_sector_header(FILE *f_iso) //Used to write Synchro signal, timestamp, and headers
{
	char i;
	unsigned char valeur;

	write_synchro_code(f_iso);    //Write synchro code "00FFFFFFFFFFFFFFFFFFFF00"

	user_data[12]=minute;    //Write the timestamp
	user_data[13]=second;
	user_data[14]=frame;

	user_data[15]=2;

	user_data[16]=0;        //Write header and subheader
	user_data[17]=0;
	user_data[18]=8;
	user_data[19]=0;
	user_data[20]=0;
	user_data[21]=0;
	user_data[22]=8;
	user_data[23]=0;


}

void write_sector_edc_ecc(FILE *f_iso)
{
	memcpy(inbuf_copy, user_data, 2448);
	/* clear fields,  which shall be build */
	memset(inbuf_copy, 0, 16);
	memset(inbuf_copy+16+8+2048, 0, 4 + 276);
	/* build fields */
	do_encode_L2(inbuf_copy, MODE_2_FORM_1, 0);

}

unsigned char read_user_data(FILE *f_iso,unsigned char user_data[],long length,unsigned char *off_value)
{
	int i;
	long position;

	position=ftell(f_iso);

	if ((position+2048)>length)
	{
		*off_value=(2048-(length-position))/8;
	}

	for(i=0;i<2048;i++)
	{
		if (position+i>length)
		{
			user_data[i+24]=0;
		}
		else
		{
			fread((char *)&user_data[i+24],1,1,f_iso);
		}
	}
	return(*off_value);
}

unsigned char convert_bin(unsigned char valeur)
{
	unsigned char temp;
	if(valeur=='A') {temp=10; return(temp);}
	if(valeur=='B') {temp=11; return(temp);}
	if(valeur=='C') {temp=12; return(temp);}
	if(valeur=='D') {temp=13; return(temp);}
	if(valeur=='E') {temp=14; return(temp);}
	if(valeur=='F') {temp=15; return(temp);}
	if(valeur==' ') {temp=0; return(temp);}

	temp=valeur-48;
	return(temp);
}

int get_new_address(char string[],t_file_pointer *new_address)
{
	(*new_address).address1=convert_bin(string[6])*16+convert_bin(string[7]);
	(*new_address).address2=convert_bin(string[4])*16+convert_bin(string[5]);
	(*new_address).address3=convert_bin(string[2])*16+convert_bin(string[3]);
	return(0);
}

int convert_position(long position,t_file_pointer *new_address)
{
	char string[10];
	char string2[10];
	long position_temp;

//	position=65587;

	if (position<(long)16)
	{
		sprintf(string,"0000000%X",position);
		get_new_address(string,new_address);
		return(0);
	}
	if (position<(long)256)
	{
		sprintf(string,"000000%X",position);
		get_new_address(string,new_address);
		return(0);
	}
	if (position<(long)4096)
	{
		sprintf(string,"00000%X",position);
		get_new_address(string,new_address);
		return(0);
	}
	if (position<(long)65536)
	{
		sprintf(string,"0000%X",position);
		get_new_address(string,new_address);
		return(0);
	}
	if (position<(long)16777216)
	{
		sprintf(string,"%6X",position);
	/*	position_temp=(unsigned long)position-(unsigned short int)position;
		position_temp=position_temp>>16;
		sprintf(string2,"00%2X",position_temp);
		string[2]=string2[2];
		string[3]=string2[3];

		get_new_address(string,new_address); */

		(*new_address).address1=convert_bin(string[4])*16+convert_bin(string[5]);
		(*new_address).address2=convert_bin(string[2])*16+convert_bin(string[3]);
		(*new_address).address3=convert_bin(string[0])*16+convert_bin(string[1]);

		return(0);
	}
}

void reinsert(FILE *f_iso,char *file_name,unsigned char user_data[],t_file_pointer tab_new[],t_file_pointer tab_source[],long *tab_position)
{
	long position;
	long length;
	int long_sector;
	int i,j;
	FILE *f_in;
	t_file_pointer new_address;

	strcat(file_name,".out");
	f_in = fopen(file_name,"rb");
	//printf("%s\n",file_name);
	length=filesize(f_in);
	//printf("%d\n",length);
	long_sector=(length/2048);
	if((length%2048)!=0) long_sector++;
	printf("Longeur= %d\n",long_sector);
	position=(((ftell(f_iso))/2352));

	convert_position(position,&new_address);

	while(tab_source[*tab_position].address3>120) //If there is a dummy entry in the source table
	{
		tab_new[*tab_position].address3=new_address.address3+128;
		tab_new[*tab_position].address2=new_address.address2;
		tab_new[*tab_position].address1=new_address.address1;
		tab_new[*tab_position].off_value=0;
		(*tab_position)++;
	};

	tab_new[*tab_position].address3=new_address.address3;
	tab_new[*tab_position].address2=new_address.address2;
	tab_new[*tab_position].address1=new_address.address1;
	tab_new[*tab_position].off_value=0;

	for(i=0;i<long_sector;i++)
	{
		write_sector_header(f_iso);
		read_user_data(f_in,user_data,length,&(tab_new[*tab_position].off_value));
		write_sector_edc_ecc(f_iso);
		update_time();                //Prepare timestamp for next sector
		for(j=0;j<2352;j++)
		{
			fwrite(&inbuf_copy[j],1,1,f_iso);
		}
	}
	(*tab_position)++;
	fclose(f_in);
}
